freeslot(
"S_ANASTASIA_STAND",
"S_ANASTASIA_IDLE",
"S_ANASTASIA_CHOOSE",
"S_ANASTASIA_STRIKE1",
"S_ANASTASIA_STRIKE2",
"S_ANASTASIA_STRIKE3",
"S_ANASTASIA_STRIKE4",
"S_ANASTASIA_STRIKE5",
"S_ANASTASIA_SPIKES1",
"S_ANASTASIA_SPIKES2",
"S_ANASTASIA_SPIKES3",
"S_ANASTASIA_SPIKES4",
"S_ANASTASIA_SPIKES5",
"S_ANASTASIA_SPIKES6",
"S_ANASTASIA_SPIKES7",
"S_ANASTASIA_WIND1",
"S_ANASTASIA_WIND2",
"S_ANASTASIA_WIND3",
"S_ANASTASIA_PINCH1",
"S_ANASTASIA_PINCH2",
"S_ANASTASIA_PINCH3",
"S_ANASTASIA_PINCH4",
"S_ANASTASIA_PINCH5",
"S_ANASTASIA_PINCH6",
"S_ANASTASIA_PINCH7",
"S_ANASTASIA_DEATH1",
"S_ANASTASIA_DEATH2",
"S_ANASTASIA_DEATH3",
"S_ANASTASIA_DEATH4",
"S_ANASTASIA_DEATH5",
"S_ANASTASIA_DEATH6",
"S_ANASTASIA_DEATH7",
"S_ANASTASIA_DEATH8",
"S_ANASTASIA_FUCKOFF1",
"S_ANASTASIA_FUCKOFF2",
"S_ANASTASIA_FUCKOFF3",
"S_ICEMIST1",
"S_ICEMIST2",
"S_ICEMIST3",
"S_ICEMIST4",
"S_ICEMIST5",
"S_ICEMIST6",
"S_ICEMIST7",
"S_ICEMIST8",
"S_ICEMIST9",
"S_ICEPARTICLE1",
"S_ICEPARTICLE2",
"S_ICEPARTICLE3",
"S_ICEPARTICLE4",
"S_ICEPARTICLE5",
"S_ICEPARTICLE6",
"S_ICEEXPLODE",
"S_ICESPIKESMALL1",
"S_ICESPIKESMALL2",
"S_ICESPIKESMALL3",
"S_ICESPIKEMEDIUM1",
"S_ICESPIKEMEDIUM2",
"S_ICESPIKEMEDIUM3",
"S_ICESPIKELARGE1",
"S_ICESPIKELARGE2",
"S_ICESPIKELARGE3",
"S_ICEEXPLODE",
"S_ICEBALLSPAWN1",
"S_ICEBALLSPAWN2",
"S_ICEBALL1",
"S_ICEBALL2",
"S_ICEWALL1",
"S_ICEWALL2",
"S_DUSTDEVILBOOTLEG1",
"S_ICEPROJECTILE1",
"S_ICEPROJECTILE2",
"S_VIYEYES",
"MT_ANASTASIA",
"MT_ICEMIST",
"MT_ICEPARTICLE",
"MT_ICESPIKESMALL",
"MT_ICESPIKEMEDIUM",
"MT_ICESPIKELARGE",
"MT_ICEBALLSPAWN",
"MT_ICEBALL",
"MT_DUSTDEVILBOOTLEG",
"MT_ICEPROJECTILE",
"MT_ICEWALL",
"MT_VIYEYES",
"SPR_ANAS",
"SPR_AICE",
"SPR_VIYY",
"sfx_anas1",
"sfx_anas2",
"sfx_anas3",
"sfx_anasp1",
"sfx_anasp2",
"sfx_anass1",
"sfx_anass2",
"sfx_anass3",
"sfx_anasre",
"sfx_anasn2",
"sfx_anased",
"sfx_fgonp",
"sfx_fgodd",
"sfx_fgodie",
"sfx_fweeee",
"sfx_anaamy",
"sfx_iceexp"
)

local soundtables = {
{sfx_anas1, sfx_anas2, sfx_anas3},
{sfx_anasp1, sfx_anasp2},
{sfx_anass1, sfx_anass2, sfx_anass3},
{sfx_anasn2}
}

sfxinfo[sfx_anas1].caption = "Perish."
sfxinfo[sfx_anas2].caption = "Cease."
sfxinfo[sfx_anas3].caption = "Peacefully."
sfxinfo[sfx_anass1].caption = "Die in peace."
sfxinfo[sfx_anass2].caption = "Die with doubt."
sfxinfo[sfx_anass3].caption = "Raise your face."
sfxinfo[sfx_anasp1].caption = "Viy, open your eyes."
sfxinfo[sfx_anasp2].caption = "Viy, your mystic eyes..."
sfxinfo[sfx_anasre].caption = "Recovery"
sfxinfo[sfx_anasn2].caption = "<-"
sfxinfo[sfx_fgonp].caption = "Noble Phantasm"
sfxinfo[sfx_fgodd].caption = "Debuff"
sfxinfo[sfx_fweeee].caption = "FWEEEEEE"
sfxinfo[sfx_anased].caption = "<Farewells>"
sfxinfo[sfx_fgodie].caption = "Vanishing..."
sfxinfo[sfx_anaamy].caption = "KYAAAAAAAAH!"


local cutscenecutseen = false

local function inQuad(t, b, c, d)
  t = FixedDiv(t, d)
  return c * FixedMul(t,t) / FRACUNIT + b
end

local function fuckTheHud(areyousure)
	if (areyousure) then
		hud.disable("score")
		hud.disable("time")
		hud.disable("rings")
		hud.disable("lives")
	else
		hud.enable("score")
		hud.enable("time")
		hud.enable("rings")
		hud.enable("lives")
	end
end

local function tableContains(tab, val)
	for k,v in ipairs(tab) do
		if (v == val) then
			return true
		end
	end
	return false
end

//////////////////
//CUSTOM ACTIONS//
//////////////////
function A_PlayRandomSound(actor, var1, var2)
	local soundtable = soundtables[var1]
	local rando = P_RandomRange(1, #soundtable)
	S_StartSound(nil, soundtable[rando])
end

function A_IceAttack(actor, var1, var2)
	local ang = actor.angle
	local dist = actor.info.radius

	if not (P_CheckPosition(actor, actor.x + dist * cos(ang), actor.y + dist * sin(ang), actor.z)) return end
	//trust me, THIS will be merciful later
	if (actor.extravalue1 > 30) then return end

	S_StartSound(actor, sfx_rail1)
	local objectToSpawn = MT_ICESPIKESMALL
	if (actor.extravalue1 / 3 == 1) then
		objectToSpawn = MT_ICESPIKEMEDIUM
	elseif (actor.extravalue1 / 3 > 1) then
		objectToSpawn = MT_ICESPIKELARGE
	end
	
	local newice = P_SpawnMobj(actor.x + FixedMul(dist,cos(ang)), actor.y + FixedMul(dist,sin(ang)), actor.z, objectToSpawn)
	newice.extravalue1 = actor.extravalue1 + 1
	newice.angle = actor.angle
end

function A_IceExplode(actor, var1, var2)
	local debris = 2
	if actor.type == MT_ICESPIKEMEDIUM then
		debris = 4
	elseif actor.type == MT_ICESPIKELARGE then
		debris = 6
	end
	S_StartSound(actor, sfx_s3k7f)
	for i = 1,debris
		local randangle = FixedAngle(P_RandomRange(0,359) * FRACUNIT)
		local randradius = P_RandomRange(10,20)
		local randspeed = P_RandomRange(4,7)
		local randvspeed = P_RandomRange(1,5)
		local ice = P_SpawnMobj(actor.x + randradius * cos(randangle), actor.y + randradius * sin(randangle), actor.z + 40*FRACUNIT, MT_ICEPARTICLE)
		P_InstaThrust(ice, randangle, randspeed*FRACUNIT)
		ice.momz = randvspeed * FRACUNIT
	end
end

function A_IceballSpawn(actor,var1,var2)
	actor.spiketable = {}
	actor.fuse = var1
	actor.speed = actor.info.speed --what the fuckkkkkk
	local spikecount = 2 + 2 * actor.tracer.phase
	for i = 1,spikecount do
		local relang = ANG1 * (360 / spikecount) * (i-1)
		local ang = actor.angle + relang
		local spike = P_SpawnMobj(actor.x + FixedMul(actor.speed,cos(ang)), actor.y + FixedMul(actor.speed,sin(ang)), actor.z + actor.height/2, MT_ICEBALL)
		table.insert(actor.spiketable, spike)
	end
end

function A_IcewallThink(actor, var1, var2)
	if not (actor.target) then P_KillMobj(actor,nil,nil) return end
	actor.angle = actor.target.angle
	P_TeleportMove(actor, 
	actor.target.x + actor.target.momx + 100*cos(actor.angle),
	actor.target.y + actor.target.momy + 100*sin(actor.angle),
	actor.target.z)
end

function A_DustDevilBootleg(actor,var1,var2)
	local scale = actor.scale
	local layer = actor.tracer
	local radius = actor.radius
	
	while (layer and layer.valid) do
		local fa = layer.angle
		P_TeleportMove(layer, layer.x + 5 * FixedMul(scale, cos(fa)), layer.y + 5 * FixedMul(scale, sin(fa)), layer.z)
		layer.scale = scale
		layer.angle = $ + ANG10 / 2
		layer.momx = actor.momx
		layer.momy = actor.momy
		layer = layer.tracer
	end
	
	if (P_IsObjectOnGround(actor)) then
		local dustang = P_RandomRange(0, 7)*ANGLE_45
		local dust = P_SpawnMobj(actor.x + 96 * FixedMul(scale, cos(dustang)), actor.y + 96 * FixedMul(scale, sin(dustang)), actor.z, MT_ARIDDUST)
		dust.state = dust.info.spawnstate + P_RandomRange(0, 2)
		dust.destscale = scale * 3
		P_SetScale(dust, dust.destscale)
	end

	actor.extravalue1 = $ + 1;
	if (actor.extravalue1 == 12) then
		actor.extravalue1 = 0

		//Create a set of items for the rising dust column
		for i = 0,3 do
			local fa = ANGLE_90*i
			local px = actor.x + 70 * FixedMul(scale, cos(fa))
			local py = actor.y + 70 * FixedMul(scale, sin(fa))
			local pz = actor.z

			layer = P_SpawnMobj(px, py, pz, MT_DUSTLAYER)
			layer.momz = 5 * scale
			layer.angle = ANGLE_90 + fa
			layer.extravalue1 = TICRATE * 3

			//Chain them
			layer.tracer = actor.tracer
			actor.tracer = layer
		end
	end

	//Whirlwind sound effect.
	if (leveltime % 70 == 0) then
		S_StartSound(actor, sfx_s3kcel)
	end
		
	//finally, the custom stuff!
	
	if not (actor.target) then
		A_FindTarget(actor, MT_PLAYER,0)
	end
	
	local exval2 = actor.extravalue2
	
	for p in players.iterate do
		if (p and p.valid and p.mo and p.mo.valid) then
			if P_CheckSight(actor, p.mo) then
				local ang = R_PointToAngle2(actor.x, actor.y, p.mo.x, p.mo.y)
				p.mo.momx = $ - cos(ang) / 3
				p.mo.momy = $ - sin(ang) / 3
				if (p.mo == actor.target) then
					actor.momx = 3* cos(ang)
					actor.momy = 3 * sin(ang)
				end
			end
		end
	end
	
	if (actor.fuse % (30 - exval2 * 11) == 0) then
		local randangle = FixedAngle(P_RandomRange(0,359) * FRACUNIT)
		local randradius = P_RandomRange(10,20)
		local randspeed = P_RandomRange(4,6)
		local changechance = P_RandomRange(1,10)
		local ice = P_SpawnMobj(actor.x + randradius * cos(randangle), actor.y + randradius * sin(randangle), actor.z + 3*actor.height/4, MT_ICEPROJECTILE)
		if (changechance > 5) then
			ice.state = S_ICEPROJECTILE2
			ice.height = 115*FRACUNIT
		end
		P_InstaThrust(ice, randangle, randspeed*FRACUNIT)
		S_StartSound(actor, sfx_s3k80)
		ice.momz = 4 * FRACUNIT
	end
	
end

////////////////
//BOSS ACTIONS//
////////////////

//TO-DO, make a version with more aggressive ice

function A_AnastasiaCheckPinch(actor,var1,var2)
	if actor.phase == 2 then
		actor.state = var1
	end
end

function A_AnastasiaThinker(actor, var1, var2)
	if (actor.health <= 0) then return end
	if not (actor.target) then
		A_FindTarget(actor, MT_PLAYER,0)
	end
	if (actor.reactiontime > 0) then
		if (actor.reactiontime == actor.info.reactiontime - 1) then
			local icewall = P_SpawnMobj(actor.x + cos(actor.angle), actor.y + sin(actor.angle), actor.z, MT_ICEWALL)
			icewall.target = actor
		end
		actor.reactiontime = $ - 1
		if (actor.reactiontime < 120) then
			if (actor.reactiontime % (30 - 6 * (actor.phase-1)) == 15) then
				A_FaceTarget(actor,nil,nil)
				S_StartSound(nil,sfx_rail1)
			end
			if (actor.reactiontime % (30 - 6 * (actor.phase-1)) == 5) then
				A_FaceTarget(actor,nil,nil)
				local randomdir = 0
				if (P_AproxDistance(actor.x - actor.target.x, actor.y - actor.target.y) < 200*FRACUNIT) then
					if (P_RandomChance(FRACUNIT/2)) then
						randomdir = -1
					else
						randomdir = 1
					end
				end
				P_InstaThrust(actor, actor.angle + randomdir * ANGLE_90, 24*FRACUNIT)
			end
		end
	else
		local mobjstokill = {}
		for m in mobjs.iterate() do
			if m.type == MT_ICEWALL and m.state == S_ICEWALL1 then
				table.insert(mobjstokill, m)
			end
		end
		for _,v in ipairs(mobjstokill) do
			P_KillMobj(v,nil,nil)
		end
		actor.reactiontime = actor.info.reactiontime
		actor.state = S_ANASTASIA_CHOOSE
	end
end

function A_AnastasiaChoose(actor,var1,var2)
	if (actor.health <= 0) then return end
	local atkstates = {
		S_ANASTASIA_STRIKE1,
		S_ANASTASIA_SPIKES1,
		S_ANASTASIA_WIND1
	}
	//local atkstates = {
	//	S_ANASTASIA_SPIKES1,
	//}
	local rando = P_RandomRange(1, #atkstates)
	actor.state = atkstates[rando]
end

function A_AnastasiaIce1(actor,var1,var2)
	if not actor.target return end
	
	local ang = actor.angle
	local repcount = var1 or 0
	local dist = var2 or 30*FRACUNIT
	
	A_FaceTarget(actor, nil, nil)
	S_StartSound(actor, sfx_rail1)
	if (repcount > 0 and actor.phase == 2) then
		for i = (-1 * repcount/2), repcount/2 do
			local newang = ang + ANG30 * i
			local newice = P_SpawnMobj(actor.x + FixedMul(dist,cos(newang)), actor.y + FixedMul(dist,sin(newang)), actor.z, MT_ICESPIKESMALL)
			newice.extravalue1 = 0
			newice.angle = newang
		end
	else
		local newice = P_SpawnMobj(actor.x + FixedMul(dist,cos(ang)), actor.y + FixedMul(dist,sin(ang)), actor.z, MT_ICESPIKESMALL)
		newice.extravalue1 = 0
		newice.angle = ang
	end
end

function A_AnastasiaIce2(actor, var1, var2)
	for p in players.iterate do
		if p and p.mo and p.mo.valid and P_CheckSight(actor, p.mo) then
			S_StartSound(nil, sfx_wdjump, p)
			local spikespawner = P_SpawnMobj(p.mo.x + p.mo.momx, p.mo.y + p.mo.momy, p.mo.z + p.mo.height/2, MT_ICEBALLSPAWN)
			spikespawner.target = p.mo
			spikespawner.tracer = actor
		end
	end
end

function A_AnastasiaIce3(actor, var1, var2)
	A_FaceTarget(actor, nil, nil)
	S_StartSound(nil, sfx_wdjump)
	local dist = 30*FRACUNIT
	local ang = actor.angle
	local windy = P_SpawnMobj(actor.x + FixedMul(dist,cos(ang)), actor.y + FixedMul(dist,sin(ang)), actor.z, MT_DUSTDEVILBOOTLEG)
	windy.extravalue1 = 0
	windy.angle = ang
	windy.fuse = (5 + actor.phase)*TICRATE
	windy.extravalue2 = actor.phase - 1 
end

function A_AnastasiaRecover(actor,var1,var2)
	if (actor.phase == 1) then
		actor.phase = 2
		S_StartSound(nil, sfx_anasre)
		for p in players.iterate do
			P_FlashPal(p,4,10)
		end
	end
	if (actor.health <= actor.info.spawnhealth) then --sanity check
		actor.health = $ + 1
	end
end

function A_AnastasiaPinch(actor, var1, var2)
	if not (cutscenecutseen) then
		for p in players.iterate do
			p.powers[pw_nocontrol] = 70
		end
		actor.movieactive = true
		actor.movietimer = $ + 1
		fuckTheHud(true)
		if (actor.movietimer > actor.maxmovietimer) then
			for p in players.iterate do
				p.powers[pw_nocontrol] = 1
			end
			actor.movieactive = false
			fuckTheHud(false)
			cutscenecutseen = true
			actor.state = S_ANASTASIA_PINCH7
		end
	else
		for p in players.iterate do
			if (p and p.valid) then
				p.defensedown = true
				p.attackdown = true
				S_StartSound(nil, sfx_fgodd, p)
			end
		end
		actor.state = S_ANASTASIA_PINCH7
	end
end

function A_AnastasiaDeath(actor, var1, var2)
	for i = 1,15 do
		local rx = P_RandomRange(-60,60) * FRACUNIT
		local ry = P_RandomRange(-60,60) * FRACUNIT
		local rz = P_RandomRange(0,90) * FRACUNIT
		local spark = P_SpawnMobj(actor.x + rx, actor.y + ry, actor.z + rz, MT_SPARK)
		spark.momz = -1*FRACUNIT
	end
end


/////////////////////
//BOSS THINKER CODE//
/////////////////////

local drawboss = nil

local function anas_prepBoss(mobj)
	mobj.fuse = 60
	mobj.phase = 1
	mobj.invulntimer = 0
	
	mobj.fuckthis = false
	
	--HUD stuff
	--don't do this, don't ATTEMPT this
	mobj.huds = {x = 0, y = 0}
	mobj.anasframes = {}
	mobj.drawstars = {}
	mobj.movietimer = 0
	mobj.maxmovietimer = 700
	mobj.movieactive = false
	
	
	--mobj.health = 1
	drawboss = mobj
end

--this should not exist. call the developers if it does
--wait....I am the developer.
local function anas_amycheck(mobj)
	if (mobj.fuckthis) then return end
	for p in players.iterate do
		if (p.mo.skin == "flicky") then
			mobj.fuckthis = true
			local shitlist = {
				MT_DUSTDEVILBOOTLEG, 
				MT_ICESPIKESMALL, 
				MT_ICESPIKEMEDIUM, 
				MT_ICESPIKELARGE, 
				MT_ICEBALL,
				MT_ICEBALLSPAWN, 
				MT_ICEPROJECTILE,
				MT_ICEWALL
			}
			local mobjstokill = {}
			for m in mobjs.iterate() do
				if tableContains(shitlist, m.type) then
					table.insert(mobjstokill, m)
				end
			end
			for _,v in ipairs(mobjstokill) do
				P_KillMobj(v,target,target)
			end
			S_FadeMusic(0, MUSICRATE)
			mobj.state = S_ANASTASIA_FUCKOFF1
			return
		end
	end

end

local function anas_think(mobj)
	P_SpawnGhostMobj(mobj)
	if (mobj.state == S_ANASTASIA_PINCH3) then --WHERE'S YOUR DECOUPLING GOD NOW
		mobj.huds.x = P_RandomRange(-5,5)
		mobj.huds.y = P_RandomRange(-5,5)
	else
		mobj.huds.x = 0
		mobj.huds.y = 0
	end
	
	--this doesn't even work lmao
	if (mobj.invulntimer > 0) then
		mobj.invulntimer = $ - 1
		if (mobj.invulntimer > 1) then	
			if (mobj.invulntimer & 1) then
				mobj.flags2 = $ | MF2_DONTDRAW
			else
				mobj.flags2 = $ & ~MF2_DONTDRAW
			end
		end
	else
		mobj.flags2 = $ &  ~MF2_DONTDRAW
		if (mobj.health > 0) then
			mobj.flags = $ | (MF_SHOOTABLE|MF_SPECIAL|MF_ENEMY)
		end
	end
end

local function anas_idleAnims(mobj)
	if (mobj.health == 0 and mobj.phase == 2) then return true end
	mobj.fuse = P_RandomRange(50,75)
	local mistcount = 4 + (5*mobj.phase)
	for i = 1,mistcount do
		local randangle = FixedAngle(P_RandomRange(0,359) * FRACUNIT)
		local randradius = P_RandomRange(10,100)
		local randspeed = P_RandomRange(2,5)
		local ice = P_SpawnMobj(mobj.x + randradius * cos(randangle), mobj.y + randradius * sin(randangle), mobj.z + 40*FRACUNIT, MT_ICEMIST)
		P_InstaThrust(ice, randangle, randspeed*FRACUNIT)
		ice.momz = -1 * FRACUNIT
	end
	return true
end

local function anas_shoulddamage(target, inflictor, source)
	if (target.health <= 0) then return false end
	if (target.invulntimer > 0) then return false end
	if (inflictor.type == MT_ICEPROJECTILE or source.type == MT_ICEPROJECTILE) then return false end
	if not (target.flags & MF_SPECIAL) then return false end
end

local function anas_damage(target, inflictor, source, damage)
	if not (inflictor) then return true end
	
	if not (inflictor.player or source.player) then
		target.health = $-1
	else
		if (inflictor.player) then
			if (inflictor.player.attackdown) then
				target.health = $-2
			else
				target.health = $-3
			end
		elseif (source.player) then
			if (source.player.attackdown) then
				target.health = $-2
			else
				target.health = $-3
			end
		end
	end
	
	S_StartSound(target, sfx_s3k5d)
	if (target.health <= 0) then
		P_KillMobj(target,inflictor, source)
	else
		target.flags = $ & ~(MF_SHOOTABLE|MF_SPECIAL|MF_ENEMY)
		target.invulntimer = 90
		//True Arena specific stuff
			local hit = inflictor or source
			if (hit) then
				if (hit.player and hit.player.valid) then
					S_StartSound(hit, sfx_ncitem, hit.player)
					//CONS_Printf(source.player, "Strike! This target has "..(target.health-1).. "HP left before it's done for!")
					P_AddPlayerScore(hit.player, 500)
					if (hit.player.hp)
						hit.player.hp = min(hit.player.hp_max,$+1)
					end
				end
			end
	end
	return true
end

local function anas_phaseShift(target, inflictor, source)
	local shitlist = {
	MT_DUSTDEVILBOOTLEG, 
	MT_ICESPIKESMALL, 
	MT_ICESPIKEMEDIUM, 
	MT_ICESPIKELARGE, 
	MT_ICEBALL,
	MT_ICEBALLSPAWN, 
	MT_ICEPROJECTILE,
	MT_ICEWALL
	}
	local mobjstokill = {}
	for m in mobjs.iterate() do
		if tableContains(shitlist, m.type) then
			table.insert(mobjstokill, m)
		end
	end
	for _,v in ipairs(mobjstokill) do
		P_KillMobj(v,target,target)
	end
	
	target.reactiontime = target.info.reactiontime
	if (target.phase == 1) then
		target.flags = $ & ~(MF_SHOOTABLE|MF_SPECIAL|MF_ENEMY)
		target.state = S_ANASTASIA_PINCH1
	else
		S_FadeMusic(0, 2*MUSICRATE)
		target.state = S_ANASTASIA_DEATH1
		//True Arena specific stuff
			local hit = inflictor or source
			if (hit) then
				if (hit.player and hit.player.valid) then
					P_FlashPal(hit.player, PAL_WHITE, 5)
					if (server.globallives != nil)
						//for player in players.iterate
							server.globallives = $1+1
						//end
						print("Great take down! "..hit.player.name.." gained the whole pool an extra life from finishing the target!")
					else
						P_GivePlayerLives(source.player, 1)
						print("Great take down! "..hit.player.name.." gained an extra life from finishing the target!")
					end
					S_StartSound(hit, sfx_nxdone)
				end
			end
	end
	
	return true
end

local function anas_noblephantasm(mobj)
	if not (mobj.movieactive) then return end
	if (mobj.movietimer == 5) then
		S_StartSound(nil, sfx_fgonp)
	end
	if (mobj.movietimer == 50) then
		A_PlayRandomSound(mobj,4,nil)
	end
	local ttime = 350
	local amobj = nil
	if (mobj.movietimer > ttime and mobj.movietimer < mobj.maxmovietimer) then
		for p in players.iterate do
			if (p and p.valid and p.mo and p.mo.valid) then
				p.mo.state = S_PLAY_PAIN
				if (p.awayviewmobj) then
					amobj = p.awayviewmobj
				end
			end
		end
		if (amobj) then
			P_TeleportMove(amobj, 
			(amobj.spawnpoint.x + P_RandomRange(-20,20)) * FRACUNIT,
			(amobj.spawnpoint.y + P_RandomRange(-20,20)) * FRACUNIT,
			(amobj.spawnpoint.z + P_RandomRange(-20,20)) * FRACUNIT
			)
		end	
	end
	if (mobj.movietimer == ttime) then
		for p in players.iterate do
			if (p and p.valid and p.mo and p.mo.valid) then
				--oh no no no
				P_TeleportMove(p.mo, p.mo.x - 2432 * FRACUNIT, p.mo.y, p.mo.z)
			end
		end
	end
	if (mobj.movietimer == ttime + 50) then
		S_StartSound(nil,sfx_rumble)
		P_LinedefExecute(3021,mobj,nil)
	end
	if (mobj.movietimer == ttime + 90) then
		P_LinedefExecute(3022,mobj,nil)
	end
	if (mobj.movietimer == ttime + 125) then
		S_StartSound(nil,sfx_rumble)
		P_LinedefExecute(3023,mobj,nil)
	end
	if (mobj.movietimer == ttime + 155) then
		P_LinedefExecute(3024,mobj,nil)
	end
	if (mobj.movietimer == ttime + 175) then
		S_StartSound(nil,sfx_rumble)
		P_LinedefExecute(3025,mobj,nil)
	end
	if (mobj.movietimer == ttime + 185) then
		P_LinedefExecute(3020,mobj,nil)
	end
	if (mobj.movietimer == mobj.maxmovietimer - 90) then
		for p in players.iterate do
			if (p and p.valid) then
				p.defensedown = true
				S_StartSound(nil, sfx_fgodd, p)
			end
		end
	end
	--adding a second forloop so that the debuffs appear more aesthetically
	--what the fuck
	if (mobj.movietimer == mobj.maxmovietimer - 82) then
		for p in players.iterate do
			if (p and p.valid) then
				p.attackdown = true
				S_StartSound(nil, sfx_fgodd, p)
			end
		end
	end
	
	if (mobj.movietimer == mobj.maxmovietimer - 66) then
		S_StartSound(nil, sfx_fweeee)
	end
	
	if (mobj.movietimer == mobj.maxmovietimer - 1) then
		for p in players.iterate do
			if (p and p.valid and p.mo and p.mo.valid) then
				--oh no no no
				P_TeleportMove(p.mo, p.mo.x + 2432 * FRACUNIT, p.mo.y, p.mo.z + 200*FRACUNIT)
				p.awayviewtics = 0
				P_DoPlayerPain(p)
			end
		end
	end
end

////////////////
//THINKER CODE//
////////////////

local function disengageC(mapnum)
	for p in players.iterate do
		if (p and p.valid) then
			p.attackdown = false
			p.defensedown = false
		end
	end
end

--nobody will play this in MP but like, whatever
local function disengageCPlayer(mobj)
	if (mobj.player) then
		mobj.player.attackdown = false
		mobj.player.defensedown = false
	end
end

local function playerDamage(target, inflictor, source, damage)
	if not (target.player and target.player.valid) then return end
	if (target.player.defensedown) then
		--was originally gonna halve the rings, but that seems overly sadistic, even for me
		target.player.rings = ($ + 1) *3/4
	end
	return false
end

local function icespawnThinker(mobj)
	if not (mobj and mobj.valid and mobj.spiketable and 
	mobj.target and mobj.target.player 
	and mobj.target.player.valid) then return end
	
	if (mobj.fuse > 4*TICRATE / 3) then
		if (mobj.fuse == 4 * TICRATE / 3 + 2) then S_StartSound(mobj, sfx_s3k80, mobj.target.player) end
		P_TeleportMove(mobj, mobj.target.x + mobj.target.momx, mobj.target.y + mobj.target.momy, mobj.target.z + mobj.target.height/4)
	end
	--CAPECHASE ADJUSTS THE AAAAANGLE
	mobj.angle = $ + ANG1 * 3
	local tab = mobj.spiketable
	local border1 = 2*TICRATE
	local border2 = TICRATE
	local bordermult = 7 * FRACUNIT / 3
	for i = 1, #mobj.spiketable do
		local relang = ANG1 * (360 / #mobj.spiketable) * (i-1)
		local newang = mobj.angle + relang --fuck it, it's always 4
		if (mobj.fuse > border1) then
			P_TeleportMove(tab[i], mobj.x + FixedMul(mobj.speed, cos(newang)), mobj.y + FixedMul(mobj.speed, sin(newang)), mobj.z - mobj.height/2)
		elseif (mobj.fuse >= border2) then
			local mult = mobj.speed + (border1 - mobj.fuse) * bordermult
			P_TeleportMove(tab[i], mobj.x + FixedMul(mult, cos(newang)), mobj.y + FixedMul(mult, sin(newang)), mobj.z - mobj.height/2)
		elseif (mobj.fuse > 2) then
			local temp = (border2 - mobj.fuse) * mobj.speed / border2
			local mult = max(FRACUNIT, mobj.speed + mobj.fuse * bordermult - temp)
			P_TeleportMove(tab[i], mobj.x + FixedMul(mult, cos(newang)), mobj.y + FixedMul(mult, sin(newang)), mobj.z - mobj.height/2)
		else
			P_KillMobj(tab[i],mobj,mobj)
		end
	end
end

local function icewallCollider(thing, tmthing)
	if not (tmthing.type == MT_PLAYER or tmthing.type == MT_CORK 
			or thing.type == MT_PLAYER or thing.type == MT_CORK) then return end
	if (tmthing.z > thing.z + thing.height) return false end
	if (thing.z > tmthing.z + tmthing.height) return false end
	
	local angle = 0
	
	if (tmthing.type == MT_PLAYER) then
		angle = R_PointToAngle2(thing.x, tmthing.x, thing.y, tmthing.y) - thing.angle
		if (angle < ANGLE_90 or angle > ANGLE_270) then
			tmthing.momx = -8 * cos(angle)
			tmthing.momy = -8 * sin(angle)
			return true
		else
			tmthing.momx = 8 * sin(angle)
			tmthing.momy = 8 * cos(angle)
			return true
		end
	elseif (thing.type == MT_PLAYER) then
		angle = R_PointToAngle2(tmthing.x, thing.x, tmthing.y, thing.y) - tmthing.angle
		if (angle < ANGLE_90 or angle > ANGLE_270) then
			thing.momx = -8 * cos(angle)
			thing.momy = -8 * sin(angle)
			return true
		else
			thing.momx = 8 * cos(angle)
			thing.momy = 8 * sin(angle)
			return true
		end
	elseif (tmthing.type == MT_CORK or tmthing.type == MT_ARROW) then
		S_StartSound(nil, sfx_iceexp)
		P_KillMobj(thing,tmthing,tmthing)
	elseif (thing.type == MT_CORK or thing.type == MT_ARROW) then
		S_StartSound(nil, sfx_iceexp)
		P_KillMobj(tmthing,thing,thing)
	end
end

local function viyEyes(mobj)
	mobj.scale = 6*FRACUNIT
end

////////////////
//DRAWING CODE//
////////////////


local function hpDraw(v, stplyr)
	if not (drawboss and drawboss.valid and drawboss.phase) then return end
	if (drawboss.movieactive) then return end
	
	local currhp = drawboss.health
	local maxhp = drawboss.info.spawnhealth
	local phase = drawboss.phase
	
	local hpbar = v.cachePatch("FGOHP")
	local hpbar2 = v.cachePatch("FGOHP2")
	local hpbar3 = v.cachePatch("FGOHP3")
	local hpfill1 = v.cachePatch("FGOHPB1")
	local hpfill2 = v.cachePatch("FGOHPB2")
	local hpbreak1 = v.cachePatch("FGOHPPH1")
	local hpbreak2 = v.cachePatch("FGOHPPH2")
	local drawx = 281 + drawboss.huds.x
	local drawy = 170 + drawboss.huds.y
	v.draw(drawx, drawy, hpbar)
	v.drawString(drawx - 46, drawy-2, "Anastasia", 0, "thin")

	for i = 1, maxhp do
		local subx = 3
		for j = 1,subx do
			v.draw(drawx - (subx * (i-1) + j), drawy, hpbar2)
		end
		if (phase == 1) then
			if (currhp >= i) then
				v.draw(drawx - subx * i, drawy+7, hpfill1)
			end	
		elseif (phase == 2) then
			if (currhp >= i) then
				v.draw(drawx - subx * i, drawy+7, hpfill2)
			end	
		end
	end
	
	if (phase == 1) then
		v.draw(drawx - 8, drawy + 16, hpbreak1)
	elseif (phase == 2) then
		v.draw(drawx - 8, drawy + 16, hpbreak2)
	end
	
	v.draw(drawx - 62, drawy, hpbar3)
end

local function debuffDraw(v, stplyr)
	local p = stplyr
	if p.defensedown then
		local defdown = v.cachePatch("DEFDOWN")
		v.drawScaled(10*FRACUNIT, 132*FRACUNIT,FRACUNIT/2, defdown)
	end
	if p.attackdown then
		local atkdown = v.cachePatch("ATKDOWN")
		v.drawScaled(10*FRACUNIT, 148*FRACUNIT,FRACUNIT/2, atkdown)
	end
end

--DO NOT EVEN ATTEMPT TO COPY THIS CODE, IT IS HIGHEST TIER GARBAGE
--IT'S ABYSMAL, IT'S AWFUL
--LET IT DIE
local function pinchDraw(v, stplyr)
	if not (drawboss and drawboss.valid and drawboss.phase and drawboss.movieactive) then return end
	
	local timer = drawboss.movietimer
	local maxtimer = drawboss.maxmovietimer
	local startingframe = 90
	local endingframe = 380
	local blapck = v.cachePatch("BLAPCK")
	local whipte = v.cachePatch("WHIPTE")
	local anasframes = drawboss.anasframes
	local drawstars = drawboss.drawstars
	
	if (timer > 0 and timer <= 70) then
		local transp = V_10TRANS * max(0,min(9,(36 - timer) / 4))
		v.draw(0,0,blapck, transp)
	elseif (timer < endingframe) then
		v.draw(0,0,blapck)
	end
	
	--can this be initialised only once? I dunno lol
	if (#anasframes == 0 or #drawstars == 0) then
		for i = 1,4 do
			local aframe = v.cachePatch("ANAS"..tostring(i))
			table.insert(anasframes,aframe)
		end
		for i = 1,8 do
			local star = {
				patch = v.getSpritePatch(SPR_IVSP, R_Char2Frame("F"),0),
				x = 20 + 90 * (4-i),
				y = -16*(5-i) - 52,
			}
			table.insert(drawstars, star)
		end
	end
	
	
	local drawx = 320
	local drawy = 0
	local moveendingframe = endingframe-150
	
	if (timer > startingframe and timer <= moveendingframe + 120) then
		for k,tab in ipairs(drawstars) do
			v.draw(tab.x, tab.y, tab.patch)
			tab.x = $ - 2
			tab.y = $ + 4
			if (tab.x < -30) then tab.x = $ + 360 end
			if (tab.y > 230) then tab.y = $ - 250 end
		end
		
		if (timer <= moveendingframe) then
			local newdrawx = inQuad(
			(timer - startingframe) * FRACUNIT, 
			drawx, 
			40-drawx, 
			(moveendingframe - startingframe) * FRACUNIT)
			v.draw(newdrawx, drawy, anasframes[((timer / 4) % 4) + 1])	
		else
			v.draw(40, drawy, anasframes[((timer / 4) % 4) + 1])
		end
	end
	
	if (timer > endingframe - 100 and timer <= endingframe - 30) then
		local transp = V_10TRANS * max(0,min(9,(endingframe - 76 - timer) / 4))
		v.draw(0,0,blapck, transp)
	elseif (timer >= maxtimer - 70) then
		local transp = V_10TRANS * max(0,min(9,(maxtimer - (timer+34)) / 4))
		v.draw(0,0,whipte,transp)
	end
	
	--fuck it, doing it manually
	if (timer > 86 and timer < 147) then
		v.drawString(50,170,"Viy... I beg of you.", V_YELLOWMAP|V_ALLOWLOWERCASE)
	elseif (timer > 159 and timer < 321) then
		v.drawString(50,170, "Curse and kill, steal and kill,\nfreeze and kill them all.", V_YELLOWMAP|V_ALLOWLOWERCASE)
	elseif (timer > 430 and timer < 555) then
		v.drawString(50,170, "Activate mystic eyes...\nGo rampant, Viy!", V_YELLOWMAP|V_ALLOWLOWERCASE)
	end

end

hud.add(hpDraw, "game")
hud.add(pinchDraw, "game")
hud.add(debuffDraw, "game")

addHook("MapLoad", disengageC)
addHook("MobjSpawn", disengageCPlayer, MT_PLAYER)
addHook("MobjDamage", playerDamage, MT_PLAYER)

addHook("MobjSpawn", viyEyes, MT_VIYEYES)
addHook("MobjThinker", icespawnThinker, MT_ICEBALLSPAWN)
addHook("MobjCollide", icewallCollider, MT_ICEWALL)
addHook("MobjMoveCollide", icewallCollider, MT_ICEWALL)

addHook("MobjThinker", anas_think, MT_ANASTASIA)
addHook("MobjThinker", anas_amycheck, MT_ANASTASIA)
addHook("MobjThinker", anas_noblephantasm, MT_ANASTASIA)
addHook("MobjDamage", anas_damage, MT_ANASTASIA)
addHook("MobjDeath", anas_phaseShift, MT_ANASTASIA)
addHook("MobjSpawn", anas_prepBoss, MT_ANASTASIA)
addHook("MobjFuse", anas_idleAnims, MT_ANASTASIA)