freeslot(
"MT_FBOSS"
)


rawset(_G, "getEmeraldCount", function(flags)
	local numEmeralds = 0
	if All7Emeralds(flags) then return 7 end
	local i
	local j = flags
	for i = 1, 7 do
		if (j % 2) == 1 then numEmeralds = $ + 1 end
		j = j / 2
		if j == 0 then return numEmeralds end
	end
	return numEmeralds
end)

local function BossReward(target, inflictor, source)	
	local attacker = inflictor
	if (source and source.valid)
		attacker = source
	end
	if (source == nil) return false end
	if (target == inflictor) or (target == source) print("Wow... The target killed itself?!") return false end
	if (source.player)
	   P_FlashPal(source.player, PAL_WHITE, 5)
	end  
	if not netgame then
	  if (attacker.player)
		if (attacker.player.timeshit == 0) then
				print("Perfect take down!")
			if not All7Emeralds(emeralds) then
				local emeraldtogrant = getEmeraldCount(emeralds)
				P_SpawnMobj(source.x, source.y, source.z, MT_EMERALD1+emeraldtogrant)
				local emeraldtext = tostring(emeraldtogrant+1)
				if emeraldtogrant == 0 then emeraldtext = $.."st"
				elseif emeraldtogrant == 1 then emeraldtext = $.."nd"
				elseif emeraldtogrant == 2 then emeraldtext = $.."rd"
				elseif emeraldtogrant == 6 then emeraldtext = "final"
				else emeraldtext = $.."th"
				end
				print("You also got the "..emeraldtext.." Chaos Emerald!")
			end
		else
			print("Great take down!")
		end
	  end	
	else
	  if (attacker.player)
		if (attacker.player.timeshit == 0) then
			P_GivePlayerLives(source.player, 1)
				print("Perfect take down! "..source.player.name.." gained an extra life from finishing the target!")
			if not All7Emeralds(emeralds) then
				local emeraldtogrant = getEmeraldCount(emeralds)
				P_SpawnMobj(source.x, source.y, source.z, MT_EMERALD1+emeraldtogrant)
				local emeraldtext = tostring(emeraldtogrant+1)
				if emeraldtogrant == 0 then emeraldtext = $.."st"
				elseif emeraldtogrant == 1 then emeraldtext = $.."nd"
				elseif emeraldtogrant == 2 then emeraldtext = $.."rd"
				elseif emeraldtogrant == 6 then emeraldtext = "final"
				else emeraldtext = $.."th"
				end
				print(source.player.name.." has also got the "..emeraldtext.." Chaos Emerald!")
			end
		else
			P_GivePlayerLives(source.player, 1)
			print("Great take down! "..source.player.name.." gained an extra life from finishing the target!")
		end
	  end	
	end
	S_StartSound(source, sfx_nxdone)
end

local function BossSupport(target, inflictor, source, damage)
	if (target.health > 1)
		local attacker = inflictor
		if (source and source.valid and source.player)
			attacker = source
		end
		if (source == nil)
			return false
		end
		if (target == inflictor) or (target == source)
			print("Ouch! Wait... The target hurt itself?!")
			return false
		end
		if (source.player)
	     S_StartSound(source, sfx_ncitem, source.player)
		 //CONS_Printf(source.player, "Strike! This target has "..(target.health-1).. "HP left before it's done for!")
		 P_AddPlayerScore(source.player, 500)
		 if (source.player.hp)
			source.player.hp = min(source.player.hp_max,$+1)
		 end
		end 
	end
end
//Thanks Zipper for fixing this code!//
local targetes = {
	MT_EGGMOBILE,
	MT_EGGMOBILE2,
	MT_EGGMOBILE3,
	MT_EGGMOBILE4,
	MT_EGGMOBILE7,
	MT_GREENHILLBOSS,
	MT_SANDSUB_326,
	MT_METALSONIC_BATTLE,
	MT_OLDK,
	MT_KNUCKLES,
	MT_FANG,
	MT_SHADOW,
	MT_ROBOHOOD_MINIBOSS,
	MT_SUPERHOOD,
	MT_CYBRAKDEMON,
	MT_STRAYBOLTS_BOSS,
	MT_EGGOFLAMERB,
	MT_EGGOFLAMER,
	MT_DIGGINGBOSS,
	MT_BLACKEGGMAN,
	MT_FROSTBURN,
	MT_EGGZAP,
	MT_THOKBOSS,
	MT_EGGBALLER,
	MT_EGGANIMUS,
	MT_EGGANIMUS_EX,
    MT_FBOSS,
	MT_EGGFREEZER,
	MT_REKNUCKLES
	}

for i=1,#targetes do
	addHook("MobjDeath", BossReward, targetes[i])
	addHook("MobjDamage", BossSupport, targetes[i])
end

